#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include "a2dc.h"

/* Ovaj program cita stanja sklopki i tipkala   */
/* te u tom smislu pali cetiri diode	        */

int main(void){
 int fi;
 static unsigned char i;
 static unsigned long j;
 char polje[]={92,124,47,124};
 
 puts("\n**********");
 puts("Test tipkala i sklopki");
 puts("Program ce se sam zaustaviti ili CTRL+C ili kill -9 pid");
 puts("\n**********");
 
 if ( (fi=open("/dev/das08jr_dio",O_RDWR)) <0){
	puts("\n\tNe mogu otvoriti dio!\n");
	exit (-1);
 }

/* Ukoliko ovaj program nikako ne radi, to je zato jer      */
/* je nesto sfusano u kompajliranju i_ili optimizacijama    */
/* tada umjesto zadnjeg argumenta u svim pozivima funkcije  */
/* write (a to je ovaj 1),  treba staviti sizeof( char )    */
/* Ovo je eksperimentalno hard-core rjesenje,               */ 
/* a ako netko kuzi u cemu je stos i kako treba             */
/* kompajlirati s novijim gcc-om neka javi.                 */
/* (poanta je da sve radi ok sa starijim gcc-om)            */	        

/* upali i ugasi sve diode */
i=0x00;
write(fi,&i,1);
sleep(1);
i=0xff;
write(fi,&i,1);
sleep(1);
/* ************************ */

/* citaj i pisi  */
for(j=0L;j<500L;j++){
 read(fi,&i,1);
 write(fi,&i,1);
 printf("Citam digitalni ulaz i pisem na izlaz\t%c.\r",polje[j%4]);
 fflush(stdout);
 usleep(100000);
}

close(fi);
return(1);
}
