#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>

#include "a2dc.h"

WORD sum(WORD *);

int main(void){
 int fa,fd;
 static unsigned long j;
 float data=0;
 WORD podatak[10];
 BYTE data2;
 
 puts("\n\tGlupi VU-metar --> okreni 1. pot, CTRL+C za prekid");
 puts("\t\tDa li je skala linearna? \050ha-ha\051");
 puts("\nCTRL+C za kraj.");
 
 fflush(stdout);
 sleep(2);

 /* ovaj program imitira los VU-metar tako sto cita podatke */
 /* s PRVOG (NE NULTOG) AD-kanala i u ovisnosti o iznosu    */
 /* tog napona pali i gasi diode kao sto bi trebao raditi   */
 /* VU-metar						    */
 /* Naravno da skala nije linearna, sto ima veze s tim da   */
 /* kartica -5V pretvara u 0(10), a +5V 4095(10) i nacinom  */
 /* zaokruzivanja...					    */ 
 /* Koristi se lijevi potenciometar i adc01 zato sto je     */
 /* na plocici krepao poteciometar vezan na adc00.	    */
 
 if ( (fa=open("/dev/das08jr_adc01",ADC_SOFT_TRIGGER)) <0){
	printf("\n\tNe mogu otvoriti adc1!");
	exit (-1);
 }
 if ( (fd=open("/dev/das08jr_dio",O_RDWR)) <0){
	printf("\n\tNe mogu otvoriti dio!");
	exit (-1);
 }


/* Ukoliko ovaj program nikako ne radi, to je zato jer      */
/* je nesto sfusano u kompajliranju i/ili optimizacijama    */
/* tada umjesto zadnjeg argumenta u svim pozivima funkcije  */
/* write, (to je ova jedinica) treba staviti sizeof( char ) */			          
/* Ovo je eksperimentalno hard-core rjesenje,               */ 
/* a ako netko kuzi u cemu je stos i kako treba             */
/* kompajlirati s novijim gcc-om neka javi.                 */
/* (poanta je da sve radi ok sa starijim gcc-om)            */	        


for(j=0L;j<500L;j++){
 read(fa,podatak,1);
 
 /* ovih 0.00244 je korak kvantizacije */
 
 data=(float)podatak[0]*0.00244-5.0;
 data2=(BYTE)((float)podatak[0]/4096.*255.);

if (data2 >=2 && data2 <= 3) data2=3;
if (data2 >=4 && data2 <= 7) data2=7;
if (data2 >=8 && data2 <= 15) data2=15;
if (data2 >=16 && data2 <= 31) data2=31;
if (data2 >=32 && data2 <= 63) data2=63;
if (data2 >=64 && data2 <= 127) data2=127;
if (data2 >=128 && data2 <= 255) data2=255;

/* komplementira se zato jer iznos napona zelim   */
/* pokazati svijetlom, a ne mrakom		  */
/* Time zelim reci da LED svijetli ako je na njoj */
/* logicka 0                                      */

data2=~data2;
write(fd,&data2,1);
usleep(100000);
}

close(fd);
close(fa);
return(1);
}

